import java.io.*; 
import java.util.*;

public class uf
{ 
	public static Hashtable ptgp;
	public static Hashtable gpgp;
	public static Hashtable gpfr;		
	public static int flag=0;

	public static long getRoot(long grpId)
	{
		while ((Long)gpgp.get(grpId)!=grpId)
		{
			grpId = (Long)gpgp.get(grpId);
		}
		return grpId;
	}

	public static void main(String args[])
	{
		String fileBase = "./afofoutput/shell/", line="";
		System.out.println("Hello World!");

		ptgp = new Hashtable<Long, Long>();
		gpgp = new Hashtable<Long, Long>();
		gpfr = new Hashtable<Long, Long>();
		
		int i=0;
		int counter=0;

		while (true)
		{
			try
			{
				String fileName = fileBase + i + ".grp";

				File file = new File(fileName);
				if (!file.exists())
					break;

				System.out.println(fileName);
				BufferedReader br = new BufferedReader(new FileReader(fileName));
				while ((line=br.readLine())!=null && line.length()>5)
				{
					counter++;
					if (counter%10000==0)
						System.out.println(counter);	
					//<particle id, group id>
					StringTokenizer stk = new StringTokenizer(line);
					long parId = Long.parseLong(stk.nextToken());
					long grpId = Long.parseLong(stk.nextToken());

					if (gpgp.get(grpId)==null)
						gpgp.put(grpId,grpId);

					if (ptgp.get(parId)==null)
						ptgp.put(parId,grpId);
					else
					{
						long root = getRoot((Long)ptgp.get(parId));
						long current = getRoot(grpId);	
						if (root!=current)
						{
							gpgp.put(root,current);
						}
					}
				};
				br.close();

				i++;
			}
			catch (Exception e)
			{ 
				System.out.println(i+" "+line+" "+e+" "+counter);
				break;
			}
		};

		//output
		Set<Long> keySet = gpgp.keySet();
		System.out.println(keySet.size());
		try
		{
			BufferedWriter bw = new BufferedWriter(new FileWriter("trans.trn"));
			for (Long url : keySet) {
				long root = getRoot(url);
				if (url!=root)
	  				bw.write(url + " " + root + "\r\n");
			}
			bw.close();
		}catch (Exception e){}

	}
} 
